diff --git a/hurd/hurd/signal.h b/hurd/hurd/signal.h
index eb9b0ca423..f84c4ef485 100644
--- a/hurd/hurd/signal.h
+++ b/hurd/hurd/signal.h
@@ -180,7 +180,7 @@ _hurd_critical_section_lock (void)
   struct hurd_sigstate *ss;
 
 #ifdef __LIBC_NO_TLS
-  if (__LIBC_NO_TLS())
+  if (__LIBC_NO_TLS ())
     /* TLS is currently initializing, no need to enter critical section.  */
     return NULL;
 #endif
diff --git a/hurd/hurd/threadvar.h b/hurd/hurd/threadvar.h
index 89918e34c3..414e452db5 100644
--- a/hurd/hurd/threadvar.h
+++ b/hurd/hurd/threadvar.h
@@ -49,6 +49,6 @@ extern mach_port_t __hurd_reply_port0;
 
 /* This returns either the TLS reply port variable, or a single-thread variable
    when TLS is not initialized yet.  */
-#define __hurd_local_reply_port (*(__LIBC_NO_TLS() ? &__hurd_reply_port0 : &THREAD_SELF->reply_port))
+#define __hurd_local_reply_port (*(__LIBC_NO_TLS () ? &__hurd_reply_port0 : &THREAD_SELF->reply_port))
 
 #endif	/* hurd/threadvar.h */
diff --git a/mach/setup-thread.c b/mach/setup-thread.c
index 6716813825..79ec4320b3 100644
--- a/mach/setup-thread.c
+++ b/mach/setup-thread.c
@@ -52,7 +52,7 @@ __mach_setup_thread (task_t task, thread_t thread, void *pc,
   if (error)
     return error;
 
-  tcb = _dl_allocate_tls(NULL);
+  tcb = _dl_allocate_tls (NULL);
   if (tcb == NULL)
     return KERN_RESOURCE_SHORTAGE;
 
@@ -87,7 +87,7 @@ __mach_setup_thread (task_t task, thread_t thread, void *pc,
     return error;
   assert (tssize == MACHINE_THREAD_STATE_COUNT);
 
-  _hurd_tls_new(thread, &ts, tcb);
+  _hurd_tls_new (thread, &ts, tcb);
 
   error = __thread_set_state (thread, MACHINE_THREAD_STATE_FLAVOR,
 			      (natural_t *) &ts, tssize);
diff --git a/sysdeps/mach/hurd/i386/tls.h b/sysdeps/mach/hurd/i386/tls.h
index 6cd1730887..c443552df4 100644
--- a/sysdeps/mach/hurd/i386/tls.h
+++ b/sysdeps/mach/hurd/i386/tls.h
@@ -63,7 +63,7 @@ typedef struct
 #define __LIBC_NO_TLS()							      \
   ({ unsigned short ds, gs;						      \
      asm ("movw %%ds,%w0; movw %%gs,%w1" : "=q" (ds), "=q" (gs));	      \
-     __builtin_expect(ds == gs, 0); })
+     __builtin_expect (ds == gs, 0); })
 
 /* The TCB can have any size and the memory following the address the
    thread pointer points to is unspecified.  Allocate the TCB there.  */
@@ -105,7 +105,7 @@ typedef struct
       | (((unsigned int) (tcb)) & 0xff000000) /* base 24..31 */		      \
     }
 
-# define HURD_SEL_LDT(sel) (__builtin_expect((sel) & 4, 0))
+# define HURD_SEL_LDT(sel) (__builtin_expect ((sel) & 4, 0))
 
 static inline const char * __attribute__ ((unused))
 _hurd_tls_init (tcbhead_t *tcb)
@@ -163,13 +163,13 @@ _hurd_tls_init (tcbhead_t *tcb)
      struct descriptor __desc, *___desc = &__desc;			      \
      unsigned int __count = 1;						      \
      kern_return_t __err;						      \
-     if (HURD_SEL_LDT(__sel))						      \
+     if (HURD_SEL_LDT (__sel))						      \
        __err = __i386_get_ldt ((thread), __sel, 1, &___desc, &__count);	      \
      else								      \
        __err = __i386_get_gdt ((thread), __sel, &__desc);		      \
      assert_perror (__err);						      \
      assert (__count == 1);						      \
-     HURD_DESC_TLS(___desc);})
+     HURD_DESC_TLS (___desc);})
 
 /* Install new dtv for current thread.  */
 # define INSTALL_NEW_DTV(dtvp)						      \
@@ -198,7 +198,7 @@ _hurd_tls_fork (thread_t child, thread_t orig, struct i386_thread_state *state)
   error_t err;
   unsigned int count = 1;
 
-  if (HURD_SEL_LDT(sel))
+  if (HURD_SEL_LDT (sel))
     err = __i386_get_ldt (orig, sel, 1, &_desc, &count);
   else
     err = __i386_get_gdt (orig, sel, &desc);
@@ -207,7 +207,7 @@ _hurd_tls_fork (thread_t child, thread_t orig, struct i386_thread_state *state)
   if (err)
     return err;
 
-  if (HURD_SEL_LDT(sel))
+  if (HURD_SEL_LDT (sel))
     err = __i386_set_ldt (child, sel, &desc, 1);
   else
     err = __i386_set_gdt (child, &sel, desc);
@@ -231,7 +231,7 @@ _hurd_tls_new (thread_t child, struct i386_thread_state *state, tcbhead_t *tcb)
   tcb->tcb = tcb;
   tcb->self = child;
 
-  if (HURD_SEL_LDT(sel))
+  if (HURD_SEL_LDT (sel))
     err = __i386_set_ldt (child, sel, &desc, 1);
   else
     err = __i386_set_gdt (child, &sel, desc);
diff --git a/sysdeps/mach/hurd/libc-lock.h b/sysdeps/mach/hurd/libc-lock.h
index ed45f076b3..f5a1f66a23 100644
--- a/sysdeps/mach/hurd/libc-lock.h
+++ b/sysdeps/mach/hurd/libc-lock.h
@@ -35,7 +35,7 @@ typedef struct
 typedef __libc_lock_recursive_t __rtld_lock_recursive_t;
 
 extern char __libc_lock_self0[0];
-#define __libc_lock_owner_self() (__LIBC_NO_TLS() ? &__libc_lock_self0 : THREAD_SELF)
+#define __libc_lock_owner_self() (__LIBC_NO_TLS () ? &__libc_lock_self0 : THREAD_SELF)
 
 #else
 typedef struct __libc_lock_opaque__ __libc_lock_t;